<?php
/**
 * @version		1.5.7
 * @package		Joomla
 * @subpackage	EDocman
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2011-2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined('_JEXEC') or die ;

class EDocmanModelCategories extends RADModelList
{
    public function __construct($config = array())
    {
        parent::__construct($config);
        $app = JFactory::getApplication();
        $listLength = EdocmanHelper::getConfigValue('number_categories');
        if (!$listLength)
        {
            $listLength = $app->getCfg('list_limit');
        }
        $this->state->insert('id', 'int', 0)        	
             ->insert('limit', 'int', $listLength)
             ->insert('filter_category_ids', 'string', '');
        if (isset($_REQUEST['start']) && !isset($_REQUEST['limitstart']))
        {
            $_REQUEST['limitstart'] = $_REQUEST['start'];
        }
        if (!isset($_REQUEST['limitstart']))
        {
        	$_REQUEST['limitstart'] = 0;
        }
        $this->state->setData($_REQUEST);
        $this->state->set('filter_order', 'tbl.ordering');
        if (JRequest::getVar('view') == 'categories')
        {
            $app->setUserState('edocman.limit', $this->state->limit);
        }
    }

    /**
     * Method to get categories data
     *
     * @access public
     * @return array
     */
    public function getData()
    {
        // Lets load the content if it doesn't already exist
        if (empty($this->data))
        {
            $rows = parent::getData();
            for ($i = 0, $n = count($rows); $i < $n; $i++)
            {
                $row = $rows[$i];
                $row->total_documents = EdocmanHelper::countDocuments($row->id) ;
            }
            $this->data = $rows;
        }
        return $this->data;
    }

    protected function _buildQueryWhere(JDatabaseQuery $query)
    {
        $app = JFactory::getApplication();
        $config = EdocmanHelper::getConfig() ;
        $user = JFactory::getUser();
        $userId = $user->get('id');
        $db = JFactory::getDbo();
        $query->where('tbl.published=1')
            ->where('tbl.parent_id='.$this->state->id);
     	if ($this->state->filter_category_ids)
        {
            $query->where('tbl.id IN('.$this->state->filter_category_ids.')');
        }
        $query->where("((tbl.user_ids = '' AND tbl.access IN (".implode(',', $user->getAuthorisedViewLevels()).")) OR tbl.user_ids='$userId' OR tbl.user_ids LIKE '$userId,%' OR tbl.user_ids LIKE '%,$userId,%' OR tbl.user_ids LIKE '%,$userId' OR (tbl.created_user_id=$userId AND tbl.created_user_id > 0))");
        if ($config->activate_multilingual_feature && $app->getLanguageFilter())
        {
            $query->where('tbl.language IN (' . $db->Quote(JFactory::getLanguage()->getTag()) . ',' . $db->Quote('*') . ', "")');
        }

        return $this;
    }


    /**
     * Get the current active category
     *
     * @return mixed
     */
    public function getCategory()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('*')
            ->from('#__edocman_categories')
            ->where('id='.$this->state->id);
        $db->setQuery($query);
        return $db->loadObject();
    }
}